PRO BATCH_SUBSET

  COMPILE_OPT IDL2
  
  ENVI, /RESTORE_BASE_SAVE_FILES
  
  ENVI_BATCH_INIT, LOG_FILE='BATCH.LOG'
  
  PRINT, 'START : ',SYSTIME()
  
  ;--------------------------------------------------------------------------
  ROOT_DIR = 'D:\Australia\output'

  FNS = FILE_SEARCH(ROOT_DIR, '*.img', COUNT = COUNT)
  
  PRINT, 'There ara totally', COUNT,' images.'
  
  shpfile = 'D:\Australia\World_shp\New_South_Wales.shp'
  
  OUTPUTPATH = 'D:\Australia\Subset\'
  
  ;--------------------------------------------------------------------------
  FOR i = 0, COUNT-1  DO BEGIN
    
    FILENAME = FNS[i]
    
    A = STRPOS(FILENAME, '2019')
    
    B = STRPOS(FILENAME, '_Grid_2D_reprojected')

    outname = STRMID(FILENAME, A, 20)
    
    envi_open_file, FILENAME, r_fid = fid
    
    RasterSubsetViaShapefile, fid, shpfile = shpfile, outfile = OUTPUTPATH + outname + '_New_South_Wales', r_fid = r_fid
    
    envi_file_mng, id = fid, /remove
    
  ENDFOR
  

  PRINT, 'END : ', SYSTIME()
  
  ENVI_BATCH_EXIT

END